#include "zstring.h"

vector <zchar> zstring::upper = vector <zchar> () ;
vector <zchar> zstring::lower = vector <zchar> () ;

zstring::zstring ()
    {
    init_static () ;
    ch.clear () ;
    }
    
zstring::zstring ( const zstring &from )
    {
    init_static () ;
    ch = from.ch ;
    }

zstring::zstring ( string &from )
    {
    init_static () ;
    set_from_string ( from ) ;
    }
    
zstring::zstring ( const char* from )
    {
    init_static () ;
    string t ( from ) ;
    set_from_string ( t ) ;
    }
    
void zstring::set_from_string ( string &from )
    {
    ch.clear () ;
    while ( ch.size() < from.length() ) ch.push_back ( from[ch.size()] ) ;
    }
    
void zstring::erase_all ( zchar z )
    {
    int a ;
    for ( a = 0 ; a < ch.size() ; a++ )
       {
       if ( ch[a] == z )
          {
          ch.erase ( ch.begin() + a ) ;
          a-- ;
          }
       }
    }
    
void zstring::erase_all_double ( zchar z , zchar z2 )
    {
    int a ;
    for ( a = 1 ; a < ch.size() ; a++ )
       {
       if ( ch[a-1] == z && ch[a] == z2 )
          {
          ch.erase ( ch.begin() + a ) ;
          a-- ;
          }
       }
    }
    
int zstring::get_first ( zchar z )
    {
    int a ;
    for ( a = 0 ; a < ch.size() && ch[a] != z ; a++ ) ;
    return a ;
    }
    
int zstring::get_first_unquoted ( zchar z )
    {
    int a ;
    zchar lastquote = ' ' ;
    bool quote = false ;
    for ( a = 0 ; a < ch.size() ; a++ )
        {
        if ( !quote && ch[a] == z ) return a ;
        if ( is_quote ( ch[a] ) )
           {
           if ( ch[a] == lastquote )
              {
              quote = false ;
              lastquote = ' ' ;
              }
           else
              {
              quote = true ;
              lastquote = ch[a] ;
              }
           }
        }
    return a ;
    }
    
zstring zstring::before_first ( zchar z )
    {
    return left ( get_first ( z ) ) ;
    }

zstring zstring::after_first ( zchar z )
    {
    int f = get_first ( z ) ;
    if ( f == length() ) return zstring () ;
    return mid ( f + 1 , ch.size() ) ;
    }
    
zstring zstring::mid ( int f , int t )
    {
    zstring ret ;
    for ( int a = f ; a <= t ; a++ )
       {
       if ( a < 0 || a >= ch.size() ) return ret ;
       ret.ch.push_back ( ch[a] ) ;
       }
    return ret ;
    }
        
zchar &zstring::ch_access ( int x )
    {
    if ( x < 0 || x >= ch.size() )
        {
        cerr << x << " is exceeding string limits" << endl ;
        dummy_char = 0 ;
        return dummy_char ;
        }
    return ch[x] ;
    }
    
string zstring::to_string ()
    {
    string s ;
    while ( s.length() < ch.size() ) s += (char) ch[s.length()] ;
    return s ;
    }
    
void zstring::append ( const zstring &from )
    {
    for ( int a = 0 ; a < from.ch.size() ; a++ )
        ch.push_back ( from.ch[a] ) ;
    }
    
/*ostream &operator<<(ostream &out, zstring &obj )
    {
    out <<  obj.to_string();
    return out;
    }*/

ostream &operator<<(ostream &out, zstring obj )
    {
    out <<  obj.to_string();
    return out;
    }

bool zstring::is_equal ( const zstring &from )
    {
    if ( ch.size() != from.ch.size() ) return false ;
    for ( int a = 0 ; a < ch.size() ; a++ )
        if ( ch[a] != from.ch[a] )
           return false ;
    return true ;
    }
    
void zstring::init_static ()
    {
    if ( lower.size() > 0 ) return ;
    int a ;
    for ( a = 'a' ; a <= 'z' ; a++ )
       {
       upper.push_back ( a - 'a' + 'A' ) ;
       lower.push_back ( a ) ;
       }
    upper.push_back ( '' ) ; lower.push_back ( '' ) ;
    upper.push_back ( '' ) ; lower.push_back ( '' ) ;
    upper.push_back ( '' ) ; lower.push_back ( '' ) ;
    }
    
zchar zstring::get_upper_char ( zchar z )
    {
    int a ;
    for ( a = 0 ; a < lower.size() && lower[a] != z ; a++ ) ;
    if ( a == lower.size() ) return z ;
    else return upper[a] ;
    }

zchar zstring::get_lower_char ( zchar z )
    {
    int a ;
    for ( a = 0 ; a < upper.size() && upper[a] != z ; a++ ) ;
    if ( a == upper.size() ) return z ;
    else return lower[a] ;
    }
    
void zstring::to_upper ()
    {
    for ( int a = 0 ; a < ch.size() ; a++ ) ch[a] = get_upper_char ( ch[a] ) ;
    }

void zstring::to_lower ()
    {
    for ( int a = 0 ; a < ch.size() ; a++ ) ch[a] = get_lower_char ( ch[a] ) ;
    }
    
void zstring::erase ( int from , int to )
    {
    if ( from < 0 || from >= ch.size() ) return ;
    if ( to < -1 || ( to >= 0 && to < from ) || to >= ch.size() ) return ;
    if ( to == -1 ) // one char only
        {
        ch.erase ( ch.begin() + from ) ;
        }
    else
        {
        ch.erase ( ch.begin() + from , ch.begin() + to ) ;
        }
    }
    
bool zstring::is_in ( vector <zstring> &v )
    {
    for ( int a = 0 ; a < v.size() ; a++ )
        if ( v[a] == *this )
           return true ;
    return false ;
    }
    
void zstring::trim ( bool left , bool right )
    {
    int f = 0 , t = ch.size() - 1 ;
    while ( left && f < ch.size() && is_blank ( ch[f] ) ) f++ ;
    while ( right && t > 0 && is_blank ( ch[t] ) ) t-- ;
    *this = mid ( f , t ) ;
    }
    
bool zstring::is_blank ( zchar z )
    {
    if ( z == ' ' ) return true ;
    return false ;
    }
    
bool zstring::is_quote ( zchar z )
    {
    if ( z == '"' ) return true ;
    if ( z == 39 ) return true ;
    return false ;
    }
    
void zstring::trim_quotes ()
    {
    if ( ch.size() < 2 ) return ;
    if ( ch[0] != ch[ch.size()-1] ) return ;
    if ( !is_quote ( ch[0] ) ) return ;
    if ( !is_quote ( ch[ch.size()-1] ) ) return ;
    *this = mid ( 1 , ch.size() - 2 ) ;
    }
    
int zstring::replace ( zstring what , zstring with )
    {
    int cnt = 0 ;
    int a , b ;
    for ( a = 0 ; a + what.length() < length() ; a++ )
        {
        for ( b = 0 ; b < what.length() && ch[a+b] == what.ch[b] ; b++ ) ;
        if ( b < what.length() ) continue ;
        cnt++ ;
        zstring x = left ( a ) ;
        x += with ;
        x += mid ( a + what.length() ) ;
        *this = x ;
        a = 0 ;
        }
    return cnt ;
    }
    
void zstring::explode ( zchar z , vector <zstring> &v )
    {
    v.clear () ;
    while ( !empty() )
        {
        v.push_back ( before_first ( z ) ) ;
        *this = after_first ( z ) ;
        }
    }
    
void zstring::implode ( zchar z , vector <zstring> &v )
    {
    ch.clear () ;
    if ( v.size() == 0 ) return ;
    *this = v[0] ;
    for ( int a = 1 ; a < v.size() ; a++ )
        {
        ch.push_back ( z ) ;
        append ( v[a] ) ;
        }
    }
    
void zstring::pop_back()
    {
    if ( empty() ) return ;
    ch.pop_back() ;
    }
    
