#ifndef _zstring_h_
#define _zstring_h_

#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <vector>

using namespace std;

typedef unsigned long zchar ;

class zstring
    {
//    friend ostream &operator<<(ostream&, zstring &); 
    friend ostream &operator<<(ostream&, zstring ); 
    public :
    zstring () ;
    zstring ( const zstring &from ) ;
    zstring ( const char* from ) ;
    zstring ( string &from ) ;
    
    virtual string to_string () ;
    virtual void pop_back() ;
    virtual void push_back ( zchar z ) { ch.push_back ( z ) ; }
    virtual void erase_all ( zchar z ) ;
    virtual void erase_all_double ( zchar z , zchar z2 ) ;
    virtual void erase_all_double ( zchar z ) { erase_all_double ( z , z ) ; }
    virtual int length () { return ch.size() ; }
    virtual bool empty () { return ch.empty() ; }
    virtual zstring before_first ( zchar z ) ;
    virtual zstring after_first ( zchar z ) ;
    virtual int get_first ( zchar z ) ;
    virtual int get_first_unquoted ( zchar z ) ;
    virtual zstring left ( int x ) { return mid ( 0 , x-1 ) ; }
    virtual zstring right ( int x ) { return mid ( ch.size()-x , ch.size()-1 ) ; }
    virtual zstring mid ( int f , int t ) ;
    virtual zstring mid ( int f ) { return mid ( f , ch.size() ) ; }
    virtual zchar get_upper_char ( zchar z ) ;
    virtual zchar get_lower_char ( zchar z ) ;
    virtual void to_upper () ;
    virtual void to_lower () ;
    virtual void erase ( int from , int to = -1 ) ;
    virtual bool is_in ( vector <zstring> &v ) ;
    virtual void trim ( bool left = true , bool right = true ) ;
    virtual void trim_quotes () ;
    virtual bool is_blank ( zchar z ) ;
    virtual bool is_quote ( zchar z ) ;
    virtual int replace ( zstring what , zstring with ) ;
    virtual void explode ( zchar z , vector <zstring> &v ) ;
    virtual void implode ( zchar z , vector <zstring> &v ) ;
    
    zstring & operator = ( char *s ) { string t ( s) ; set_from_string ( t ) ; return *this ; }
    zchar & operator [] ( int x ) { return ch_access ( x ) ; }
    zstring & operator += ( zstring from ) { append ( from ) ; return *this ; }
    zstring & operator += ( char *from ) { append ( zstring ( from ) ) ; return *this ; }
    bool operator == ( zstring &z ) { return is_equal ( z ) ; }
    bool operator != ( zstring &z ) { return !is_equal ( z ) ; }
    bool operator == ( char *z ) { return is_equal ( zstring ( z ) ) ; }
    bool operator != ( char *z ) { return !is_equal ( zstring ( z ) ) ; }
    
    private :
    virtual void set_from_string ( string &s ) ;
    virtual zchar &ch_access ( int x ) ;
    virtual void append ( const zstring &from ) ;
    virtual bool is_equal ( const zstring &from ) ;
    virtual void init_static () ;
    
    vector <zchar> ch ;
    zchar dummy_char ;
    
    static vector <zchar> lower , upper ;
    } ;

/*
class zxml
    {
    public :
    zxml () ;
    
    private :
    zxml *parent ;
    vector <zstring> tk , tv ; // Tag keys, tag values
    zstring name ; // B, I, TABLE, etc.
    vector <zxml*> child ; // Alternating with
    } ;
*/
#endif
